
<p>The aim of this module is to set up a testing environment for the
scarlet router/gateway. The router can also be tested by installing
slackware and scarlet in an old computer box, and making the
neccessary network connections. However this requires some resources
(at least two computers, network cards, network cables, a hub
etc.). It also takes some time to modify the environment for testing
purposes, like adding another network card, decreasing RAM, etc. On
the other hand, using these scripts, all that is needed for testing is
just a computer with sufficient RAM (and optionally a network card for
having access to internet).</p>

<p>The idea is to run another system inside the main system using 'qemu'.
Let us call the main system (which can be ScientificLinux or any other
linux system,) the HOST system, and lets call the guest system the
TESTBOX, since it will be the system of the router/gateway which will
be tested. The figure 'physical-diagram' gives an idea about this
situation: we have a guest system which is being emulated and runs
simultaniously within the host system.</p>

<table  class="figure" align="center">
  <tr><td>
    <img src="{{GRAPHICS}}testing/physical-diagram.png" />
  </td></tr>
</table>

<p>The emulation software, 'qemu', gives also the possibility to emulate
network interfaces of the TESTBOX and to connect them to some virtual
interfaces of the HOST. The figure 'physical-network-diagram' shows
that TESTBOX has 3 network interfaces (eth0, eth1, eth2) which are
"physically" connected to the three additional virtual interfaces of
the HOST (tap0, tap1 and tap2).</p>

<table class="figure" align="center">
  <tr><td>
    <img src="{{GRAPHICS}}testing/physical-network-diagram.png" />
  </td></tr>
</table>

<p>By properly configuring these "virtually-physical" network interfaces
and connections, we can manage to build a logical network like that
which is shown in the figure 'logical-network-diagram', which is
sufficient for testing the functionality of the router/gateway. The
TESTBOX uses the HOST as the gateway to internet. CLIENT1 is a client
in the LAN1 (which is connected to eth1 of TESTBOX) and CLIENT2 is a
client in LAN2.  Both of them use TESTBOX as gateway.  'Admin' is a
box that can be used to access TEXTBOX via ssh. CLIENT1, CLIENT2 and
Admin can be performed by HOST, which can be in several roles.</p>

<table class="figure" align="center">
  <tr><td>
    <img src="{{GRAPHICS}}testing/logical-network-diagram.png" />
  </td></tr>
</table>

<p>This way we have built a network where the TESTBOX serves as
router/gateway for two LANs, each of them connected to one of its LAN
interfaces. The HOST system can be configured to be on the WAN side of
the TESTBOX or on each of the LAN networks, in order to test it from
each side. It can also access it by ssh, using the admin IP (because
TESTBOX should deny shell access from outside, for security resons,
except from the access IP).</p>


<h2>Download</h2>

<p><a
href="http://sourceforge.net/project/showfiles.php?group_id=164743">Download
release files</a> or get the latest version from Subversion with a
command like this: 
<pre>$ svn checkout https://svn.sourceforge.net/svnroot/netaccess/scarlet/testing</pre>
</p>
